Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SumOfSquares.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SumOfSquares.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SumOfSquares.cs	(revision 15017)
@@ -14,5 +14,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.SumOfSquares) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SuperAnagrams.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SuperAnagrams.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/SuperAnagrams.cs	(revision 15017)
@@ -16,5 +16,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.SuperAnagrams) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Syllables.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Syllables.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/Syllables.cs	(revision 15017)
@@ -16,5 +16,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.Syllables) {
         Name = Name,
         Description = Description,
@@ -26,5 +26,5 @@
         TrainingCount = 100,
         TestCount = 1000,
-        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.Char | DataTypes.String,
+        EnabledDataTypes = DataTypes.Exec | DataTypes.Integer | DataTypes.Boolean | DataTypes.Char | DataTypes.String | DataTypes.Print,
         MaxSize = 800,
         EvalLimit = 1600,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorAverage.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorAverage.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorAverage.cs	(revision 15017)
@@ -12,5 +12,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.VectorAverage) {
         Name = Name,
         Description = Description,
@@ -34,4 +34,5 @@
         InputFloatVector = new[] { ExampleArgumentConverter.ConvertDoubles(input[0]) },
         OutputFloat = ExampleArgumentConverter.ConvertDoubles(output[0]),
+        OutputFloatPrecision = 4
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorSummed.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorSummed.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/VectorSummed.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.VectorSummed) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WallisPi.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WallisPi.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WallisPi.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.WallisPi) {
         Name = Name,
         Description = Description,
@@ -44,4 +44,5 @@
         InputInteger = ExampleArgumentConverter.ConvertIntegers(input),
         OutputFloat = ExampleArgumentConverter.ConvertDoubles(output),
+        OutputFloatPrecision = 5
       };
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WordStats.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WordStats.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/WordStats.cs	(revision 15017)
@@ -17,5 +17,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.WordStats) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/XWordLines.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/XWordLines.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problem.ProgramSynthesis.BenchmarkSuite/Problems/XWordLines.cs	(revision 15017)
@@ -15,5 +15,5 @@
 
     public override ProblemData CreateProblemData() {
-      return new ProblemData {
+      return new ProblemData(ProblemType.XWordLines) {
         Name = Name,
         Description = Description,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringRandomErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringRandomErc.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/String/StringRandomErc.cs	(revision 15017)
@@ -49,5 +49,5 @@
 
     public override string GetErcValue(IRandom random) {
-      if (random.NextDouble().IsAlmost(NewStringProbability) || generatedValues.Count == 0) {
+      if (random.NextDouble() < NewStringProbability || generatedValues.Count == 0) {
         var value = StringGenerator.RandomString(
           AllowLowercaseLetters,
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/StringVector/StringVectorConstantsErc.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/StringVector/StringVectorConstantsErc.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/StringVector/StringVectorConstantsErc.cs	(revision 15017)
@@ -16,4 +16,5 @@
 
     public StringVectorConstantsErc() : this(false, 1d) { }
+    public StringVectorConstantsErc(params string[][] arrays) : this(true, 1d, arrays.Select(x => new StringArray(x)).ToArray()) { }
     public StringVectorConstantsErc(params StringArray[] arrays) : this(true, 1d, arrays) { }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.Designer.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.Designer.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.Designer.cs	(revision 15017)
@@ -34,6 +34,6 @@
       this.errorProvider.SetIconAlignment(this.nameTextBox, System.Windows.Forms.ErrorIconAlignment.MiddleLeft);
       this.errorProvider.SetIconPadding(this.nameTextBox, 2);
-      this.nameTextBox.Location = new System.Drawing.Point(63, 0);
-      this.nameTextBox.Size = new System.Drawing.Size(645, 20);
+      this.nameTextBox.Location = new System.Drawing.Point(75, 0);
+      this.nameTextBox.Size = new System.Drawing.Size(633, 20);
       //
       // infoLabel
@@ -54,8 +54,8 @@
       this.possibilityTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
-      this.possibilityTextBox.Location = new System.Drawing.Point(63, 25);
+      this.possibilityTextBox.Location = new System.Drawing.Point(75, 25);
       this.possibilityTextBox.Name = "possibilityTextBox";
-      this.possibilityTextBox.Size = new System.Drawing.Size(670, 20);
-      this.possibilityTextBox.TabIndex = 1;
+      this.possibilityTextBox.Size = new System.Drawing.Size(658, 20);
+      this.possibilityTextBox.TabIndex = 2;
       //
       // ErcOptionListView
@@ -69,4 +69,5 @@
       this.ErcOptionListView.Name = "ErcOptionListView";
       this.ErcOptionListView.ReadOnly = false;
+      this.ErcOptionListView.ShowDetails = true;
       this.ErcOptionListView.Size = new System.Drawing.Size(733, 434);
       this.ErcOptionListView.TabIndex = 3;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Erc/Views/ErcOptionsView.cs	(revision 15017)
@@ -15,12 +15,24 @@
 
       possibilityTextBox.Validating += PossibilityTextBoxValidating;
+      possibilityTextBox.KeyDown += PossibilityTextBoxKeyDown;
+    }
+
+    private void PossibilityTextBoxKeyDown(object sender, System.Windows.Forms.KeyEventArgs e) {
+      if (e.KeyCode == System.Windows.Forms.Keys.Enter) {
+        Validate();
+      }
     }
 
     private void PossibilityTextBoxValidating(object sender, System.ComponentModel.CancelEventArgs e) {
+      var text = possibilityTextBox.Text.Trim();
+      if (text.EndsWith("%")) {
+        text = text.Substring(0, text.Length - 1);
+      }
+
       double value;
-      if (double.TryParse(possibilityTextBox.Text, out value)) {
-        possibilityTextBox.Text = value.ToString(PERCENTAGE_FORMAT);
+      if (double.TryParse(text, out value)) {
+        possibilityTextBox.Text = (value / 100.0).ToString(PERCENTAGE_FORMAT);
       } else {
-        possibilityTextBox.Text = "0 %";
+        possibilityTextBox.Text = "0%";
         e.Cancel = true;
       }
@@ -37,4 +49,10 @@
         base.Content = value;
       }
+    }
+
+    protected override void OnReadOnlyChanged() {
+      base.OnReadOnlyChanged();
+
+      possibilityTextBox.ReadOnly = ReadOnly;
     }
 
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Settings.StyleCop
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Settings.StyleCop	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis.Base/Settings.StyleCop	(revision 15017)
@@ -0,0 +1,1 @@
+<StyleCopSettings Version="105" />
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/HeuristicLab.Problems.ProgramSynthesis.csproj	(revision 15017)
@@ -121,4 +121,6 @@
     <Compile Include="Push\Attributes\PushStackAttribute.cs" />
     <Compile Include="Push\Configuration\IEnabledExpressionsConfiguration.cs" />
+    <Compile Include="Push\Configuration\PushConfigurationBase.cs" />
+    <Compile Include="Push\Configuration\PushConfigurationParameterCollection.cs" />
     <Compile Include="Push\Data\List\SkipList.cs" />
     <Compile Include="Push\Data\Pool\IPooledObject.cs" />
@@ -126,5 +128,4 @@
     <Compile Include="Push\Data\Pool\ObjectPool.cs" />
     <Compile Include="Push\Data\Pool\PooledList.cs" />
-    <Compile Include="Push\Data\Tree\Tree.cs" />
     <Compile Include="Push\Data\Tree\TreeExtensions.cs" />
     <Compile Include="Push\Data\Tree\TreeNode.cs" />
@@ -147,5 +148,4 @@
     <Compile Include="Push\Expressions\FlushExpressions.cs" />
     <Compile Include="Push\Expressions\IntegerExpressions.cs" />
-    <Compile Include="Push\Expressions\LoopExpression.cs" />
     <Compile Include="Push\Expressions\NameExpressions.cs" />
     <Compile Include="Push\Expressions\PopExpressions.cs" />
@@ -184,6 +184,9 @@
     <Compile Include="Push\Expressions\YankDuplicateExpressions.cs" />
     <Compile Include="Push\Expressions\YankExpressions.cs" />
+    <Compile Include="Push\Extensions\CharExtentions.cs" />
     <Compile Include="Push\Extensions\CollectionExtensions.cs" />
     <Compile Include="Push\Extensions\ControlExntensions.cs" />
+    <Compile Include="Push\Extensions\LongExtensions.cs" />
+    <Compile Include="Push\Extensions\RandomExtensions.cs" />
     <Compile Include="Push\Generators\CodeGenerator\CodeGeneratorUtils.cs" />
     <Compile Include="Push\Generators\CodeGenerator\LinearCodeGenerator.cs" />
@@ -236,4 +239,10 @@
       <DependentUpon>BenchmarkSuitePushSolutionView.cs</DependentUpon>
     </Compile>
+    <Compile Include="Push\Views\PushProgramTreeView.cs">
+      <SubType>Component</SubType>
+    </Compile>
+    <Compile Include="Push\Views\PushProgramTreeView.Designer.cs">
+      <DependentUpon>PushProgramTreeView.cs</DependentUpon>
+    </Compile>
   </ItemGroup>
   <ItemGroup>
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Attributes/PushExpressionAttriubte.cs	(revision 15017)
@@ -10,9 +10,22 @@
     public readonly string ExpressionName;
     public readonly bool ManipulatesExec;
+    public readonly uint ExecIn;
 
-    public PushExpressionAttribute(StackTypes stackType, string expressionName, StackTypes additionalStackDependencies = default(StackTypes)) {
+    /// <summary>
+    /// Determines if the expression is visible to the user during the configuration phase for example.
+    /// </summary>
+    public readonly bool IsHidden;
+
+    public PushExpressionAttribute(
+      StackTypes stackType,
+      string expressionName,
+      StackTypes additionalStackDependencies = default(StackTypes),
+      uint execIn = 0,
+      bool isHidden = false) {
       StackType = stackType;
       AdditionalStackDependencies = additionalStackDependencies;
       ExpressionName = expressionName;
+      ExecIn = execIn;
+      IsHidden = isHidden;
       ManipulatesExec = stackType == StackTypes.Exec || AdditionalStackDependencies.HasFlag(StackTypes.Exec);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/IReadonlyPushConfiguration.cs	(revision 15017)
@@ -11,11 +11,13 @@
     int MaxStringLength { get; }
     int MaxVectorLength { get; }
-    int MinPointsInProgram { get; }
     int MaxPointsInProgram { get; }
     int MaxPointsInRandomExpression { get; }
     bool TopLevelPushCode { get; }
     bool TopLevelPopCode { get; }
+    int MaxParenthesesClose { get; }
+    double ParenthesesCloseBiasLevel { get; }
     IReadOnlyErcOptions ErcOptions { get; }
     IReadOnlyList<string> EnabledExpressions { get; }
+    string FloatStringFormat { get; }
   }
 }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfiguration.cs	(revision 15017)
@@ -25,7 +25,10 @@
       TopLevelPopCode = false;
       MaxPointsInRandomExpression = 64;
-      MaxStringLength = 128;
-      MaxVectorLength = 64;
-      MaxDepth = 32;
+      MaxStringLength = 1000;
+      MaxVectorLength = 500;
+      MaxDepth = 100;
+      FloatStringFormat = "R";
+      MaxParenthesesClose = 4;
+      ParenthesesCloseBiasLevel = 1;
 
       InitEnabledStacks();
@@ -58,4 +61,7 @@
       MaxVectorLength = origin.MaxVectorLength;
       MaxDepth = origin.MaxDepth;
+      FloatStringFormat = origin.FloatStringFormat;
+      MaxParenthesesClose = origin.MaxParenthesesClose;
+      ParenthesesCloseBiasLevel = origin.ParenthesesCloseBiasLevel;
     }
 
@@ -67,4 +73,6 @@
     }
 
+    [Storable]
+    public string FloatStringFormat { get; set; }
 
     [Storable]
@@ -92,6 +100,11 @@
       }
     }
-
     IReadOnlyList<string> IReadOnlyPushConfiguration.EnabledExpressions { get { return enabledExpressions; } }
+
+    [Storable]
+    public int MaxParenthesesClose { get; set; }
+    [Storable]
+    public double ParenthesesCloseBiasLevel { get; set; }
+
 
     [Storable]
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationBase.cs	(revision 15017)
@@ -0,0 +1,205 @@
+﻿using System;
+using System.Collections.Generic;
+using System.Linq;
+
+namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Expressions;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+
+  [StorableClass]
+  public abstract class PushConfigurationBase : NamedItem, IEnabledExpressionsConfiguration {
+
+    protected PushConfigurationBase() {
+      Name = "Push Configuration";
+
+      enabledExpressions = ExpressionTable.ExpressionNames.ToList();
+      enabledStacks = new Dictionary<StackTypes, bool>();
+
+      InitEnabledStacks();
+    }
+
+    [StorableConstructor]
+    protected PushConfigurationBase(bool deserializing) : base(deserializing) { }
+
+    protected PushConfigurationBase(PushConfigurationBase origin, Cloner cloner) : base(origin, cloner) {
+      enabledExpressions = origin.EnabledExpressions.ToList();
+      enabledStacks = origin.EnabledStacks.ToDictionary(x => x.Key, x => x.Value);
+    }
+
+    [Storable]
+    private readonly Dictionary<StackTypes, bool> enabledStacks;
+
+    public IReadOnlyDictionary<StackTypes, bool> EnabledStacks { get { return enabledStacks; } }
+
+    public event EventHandler<EnabledExpressionsChangedEventArgs> EnabledExpressionsChanged;
+
+    [Storable]
+    protected readonly List<string> enabledExpressions;
+
+    public IList<string> EnabledExpressions
+    {
+      get { return enabledExpressions; }
+      set
+      {
+        var removedExpressions = enabledExpressions.ToArray();
+        enabledExpressions.Clear();
+        enabledExpressions.AddRange(value);
+
+        if (EnabledExpressionsChanged != null) {
+          EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(value, removedExpressions));
+        }
+      }
+    }
+
+    private void InitEnabledStacks(bool state = true) {
+      foreach (StackTypes type in Enum.GetValues(typeof(StackTypes))) {
+        if (!enabledStacks.ContainsKey(type) && type != StackTypes.None)
+          enabledStacks.Add(type, state);
+      }
+    }
+
+    public void SetEnabledStacks(StackTypes types) {
+      // Disable all
+      EnabledExpressions.Clear();
+
+      foreach (StackTypes type in Enum.GetValues(types.GetType())) {
+        if (type == StackTypes.None) continue;
+        enabledStacks[type] = false;
+      }
+
+      foreach (var pair in ExpressionTable.StackDependencyToNamesTable) {
+        if (types.HasFlag(pair.Key)) {
+          foreach (var name in pair.Value) {
+            EnableExpression(name, true);
+          }
+        }
+      }
+    }
+
+    public void EnableExpressionOfStack(StackTypes types) {
+      EnableExpressions(ExpressionTable.StackTypeToNamesTable[types]);
+    }
+
+    public void EnableExpressionDependentOnStack(StackTypes types) {
+      var names = ExpressionTable.StackDependencyToNamesTable[types].Where(
+        name => {
+          var type = ExpressionTable.NameToTypeTable[name];
+          var attribute = ExpressionTable.TypeToAttributeTable[type];
+
+          return (attribute.StackType | attribute.AdditionalStackDependencies)
+            .ToEnumerable()
+            .All(st => enabledStacks.ContainsKey(st) && enabledStacks[st]);
+        });
+
+      EnableExpressions(names);
+    }
+
+    private void EnableExpressions(IEnumerable<string> names) {
+      foreach (var name in names.Except(EnabledExpressions))
+        EnabledExpressions.Add(name);
+
+      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(names, new string[0]));
+      }
+    }
+
+    public void DisableExpressionsOfStack(StackTypes types) {
+      DisableExpressions(ExpressionTable.StackTypeToNamesTable[types]);
+    }
+
+    public void DisableExpressionsDependentOnStack(StackTypes types) {
+      var names = ExpressionTable.StackDependencyToNamesTable
+          .Where(pair => pair.Key.HasFlag(types))
+          .SelectMany(pair => pair.Value);
+
+      DisableExpressions(names);
+    }
+
+    private void DisableExpressions(IEnumerable<string> names) {
+      foreach (var name in names.Intersect(EnabledExpressions))
+        EnabledExpressions.Remove(name);
+
+      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(new string[0], names));
+      }
+    }
+
+    public void EnableExpression(string name, bool enableStackIfDisabled = false) {
+      if (EnabledExpressions.Contains(name)) return;
+
+      EnabledExpressions.Add(name);
+
+      if (enableStackIfDisabled) {
+        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == name).Key;
+        var attribute = ExpressionTable.TypeToAttributeTable[type];
+        enabledStacks[attribute.StackType] = true;
+      }
+
+      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(
+          new[] { name },
+          new string[0]));
+      }
+    }
+
+    public void DisableExpression(string name, bool disableStackIfEnabled = false) {
+      if (!EnabledExpressions.Contains(name)) return;
+
+      EnabledExpressions.Remove(name);
+
+      if (disableStackIfEnabled) {
+        var type = ExpressionTable.TypeToNameTable.Single(x => x.Value == name).Key;
+        var attribute = ExpressionTable.TypeToAttributeTable[type];
+        enabledStacks[attribute.StackType] = false;
+      }
+
+      if (EnabledExpressionsChanged != null) {
+        EnabledExpressionsChanged(this, new EnabledExpressionsChangedEventArgs(
+          new string[0],
+          new[] { name }));
+      }
+    }
+
+    public void EnableExpression<T>(bool enableStackIfDisabled = false) where T : Expression {
+      var attribute = ExpressionTable.TypeToAttributeTable[typeof(T)];
+      EnableExpression(attribute.ExpressionName, enableStackIfDisabled);
+    }
+
+    public void DisableExpression<T>(bool disableStackIfEnabled = false) where T : Expression {
+      var attribute = ExpressionTable.TypeToAttributeTable[typeof(T)];
+      DisableExpression(attribute.ExpressionName, disableStackIfEnabled);
+    }
+
+    public void SetExpression(string name, bool state, bool cascadeForStack = false) {
+      if (state) EnableExpression(name, cascadeForStack);
+      else DisableExpression(name, cascadeForStack);
+    }
+
+    public void SetExpression<T>(bool state, bool cascadeForStack = false) where T : Expression {
+      if (state) EnableExpression<T>(cascadeForStack);
+      else DisableExpression<T>(cascadeForStack);
+    }
+
+    public void EnableStack(StackTypes type, bool enableExpressions = true, bool enableDependencies = true) {
+      enabledStacks[type] = true;
+
+      if (enableExpressions) EnableExpressionOfStack(type);
+      if (enableDependencies) EnableExpressionDependentOnStack(type);
+    }
+
+    public void DisableStack(StackTypes type, bool disableExpressions = true, bool disableDependencies = true) {
+      enabledStacks[type] = false;
+
+      if (disableExpressions) DisableExpressionsOfStack(type);
+      if (disableDependencies) DisableExpressionsDependentOnStack(type);
+    }
+
+    public void SetStack(StackTypes type, bool state, bool setExpressions = true, bool setDependencies = true) {
+      if (state) EnableStack(type, setExpressions, setDependencies);
+      else DisableStack(type, setExpressions, setDependencies);
+    }
+  }
+}
